<template>
  <div class="nuxt-p5" :id="id"></div>
</template>

<script>
  import { eventsNames, domEventNames } from '../../helpers/p5';

  export default {
    name: "NuxtP5",
    props: {
      id: { type: String, required: true },
      width: {},
      height: {},
      preventDefault: { type: Boolean, default: true },
    },
    data() {
      return {
        p5Instance: undefined,
      };
    },
    methods: {
      emitCanvasSize() {
        this.$emit('size', {
          width: this.w,
          height: this.h,
          leftTopX: this.minX,
          rightTopX: this.maxX,
          leftTopY: this.minY,
          leftBottomY: this.maxY,
        });
      },
      calculateSize(size, domSize) {
        if (size) {
          const isNumber = typeof size === 'number';
          const isString = typeof size === 'string';
          const isPixelString = typeof size === 'string' && size.includes('px');
          const isPercentageString = typeof size === 'string' && size.includes('%');
          if (isNumber) {
            return size;
          } else if (isString) {
            if (isPixelString) {
              return Number(size.replace(/px/gi, ''));
            } else if (isPercentageString) {
              return Number(size.replace(/%/gi, '')) / 100 * domSize;
            }
            return Number(size);
          }
          return domSize;
        }
        return domSize;
      },
      resizeCanvas() {
        const dom = document.getElementById(this.id);
        const domRect = dom.getBoundingClientRect();
        const domWidth = document.getElementById(this.id).offsetWidth;
        const domHeight = document.getElementById(this.id).offsetHeight;
        this.w = this.calculateSize(this.width, domWidth);
        this.h = this.calculateSize(this.height, (domHeight > 0) ? domHeight : this.w / 16 * 9);
        this.minX = domRect.left;
        this.maxX = domRect.right;
        this.minY = domRect.top;
        this.maxY = domRect.top + this.h;

        // set the width of canvas's wrapper same as canvas
        if (this.width) {
          document.getElementById(this.id).style.width = `${this.width}px`;
        }

        // emit width and height for parent
        this.emitCanvasSize();
      },
      setPreventDefault() {
        const parentDom = document.getElementById(this.id);
        domEventNames.forEach((eventName) => {
          parentDom.addEventListener(eventName, (event) => {
            event.preventDefault();
          }, true);
        });
      },
    },
    mounted() {
      this.resizeCanvas();
      const P5 = require('p5');
      this.p5Instance = new P5((sketch) => {
        // variables
        sketch.vueData = {};

        // events initialize
        eventsNames.forEach((eventName) => {
          sketch[eventName] = ($event) => {
            this.$emit(eventName, sketch, $event);
          };
        });

        // setup
        sketch.setup = () => {
          const canvas = sketch.createCanvas(this.w, this.h);
          canvas.parent(`#${this.id}`);
          this.$emit('setup', sketch);
        };

        // windowResized: useful for RWD
        sketch.windowResized = () => {
          this.resizeCanvas();
          sketch.resizeCanvas(this.w, this.h);
        }
      });
      if (this.preventDefault) {
        this.setPreventDefault();
      }
    },
  }
</script>

<style lang="scss">
  .nuxt-p5 {
    canvas {
      border-radius: 8px;
    }
  }
</style>
